//
// fragment shader for Variance Shadow Maps
//

uniform sampler2D	vsmMap;
uniform sampler2D	mainMap;

void main (void)
{
	vec4	clr  = texture2D ( mainMap, gl_TexCoord [0].xy );
	vec4	tex  = gl_TexCoord [1] / gl_TexCoord [1].w;
	vec4	vsm  = texture2D ( vsmMap, tex.xy );
	float	mu   = vsm.x;
	float	s2   = vsm.y - mu*mu;
	float	pmax = s2 / ( s2 + (tex.z - mu)*(tex.z - mu) );
	
	gl_FragColor = clr;
	
	if ( tex.z >= vsm.x )
		gl_FragColor = vec4 ( vec3 ( pmax ), 1.0 ) * clr;
}
